cooldown = 50

f = open("blocks_minecraft.txt")
blocks = f.read()
f.close()

blocks = blocks.split("\n")

look = open("look.mcfunction", "w")
look.write("scoreboard players set @s clic_detection 0\n")
look.close()

transform = open("transform_into.mcfunction", "w")
transform.write("execute as @e[type=falling_block] run data modify entity @s CustomName set value '\"Old_Block\"'\n")
transform.close()

for i, block in enumerate(blocks):
    plus = ",Properties:{face:\"floor\"}" if block.split("_")[-1] == "button" else "" 
    shulker = ""
    
    block = block.split(" ")
    if block[-1] == "X":
        shulker = f"execute unless block ~ ~ ~ {block[0]} if score @s transform_id matches {i+1} if score @s timer matches 50.. at @s align x align y align z positioned ~0.5 ~ ~0.5 unless block ~ ~ ~ {block[0]} unless entity @e[type=shulker,team=SHULKER,distance=..0.5] if block ~ ~ ~ minecraft:air run summon shulker ~ ~ ~ " + "{Invulnerable:1b,NoAI:1b,NoGravity:1b,Silent:1b,Team:SHULKER,ActiveEffects:[{Id:14,Duration:-1,Amplifier:0,ShowParticles:0b}]}\n" + f"execute unless block ~ ~ ~ {block[0]} if score @s transform_id matches {i+1} if score @s timer matches 50.. at @s align x align y align z positioned ~0.5 ~ ~0.5 unless block ~ ~ ~ {block[0]} unless entity @e[type=shulker,team=SHULKER,distance=..0.5] if block ~ ~ ~ minecraft:water run summon shulker ~ ~ ~ " + "{Invulnerable:1b,NoAI:1b,NoGravity:1b,Silent:1b,Team:SHULKER,ActiveEffects:[{Id:14,Duration:-1,Amplifier:0,ShowParticles:0b}]}\n" + f"execute unless block ~ ~ ~ {block[0]} if score @s transform_id matches {i+1} if score @s timer matches 50.. at @s align x align y align z positioned ~0.5 ~ ~0.5 unless block ~ ~ ~ {block[0]} unless entity @e[type=shulker,team=SHULKER,distance=..0.5] if block ~ ~ ~ minecraft:light run summon shulker ~ ~ ~ " + "{Invulnerable:1b,NoAI:1b,NoGravity:1b,Silent:1b,Team:SHULKER,ActiveEffects:[{Id:14,Duration:-1,Amplifier:0,ShowParticles:0b}]}\n"       
    
    block = block[0]
    
    look = open(f"look_at_blocks/look_{block}.mcfunction", "w")
    
    look.write(f"execute if block ~ ~ ~ {block} run scoreboard players set @s transform_id {i+1}\nexecute if entity @s[distance=..4.5] if block ~ ~ ~ air positioned ^ ^ ^0.5 run function transformintoblocks:look_at_blocks/look_{block}\nexecute if entity @s[distance=..4.5] if block ~ ~ ~ water positioned ^ ^ ^0.5 run function transformintoblocks:look_at_blocks/look_{block}\nexecute if entity @s[distance=..4.5] if block ~ ~ ~ light positioned ^ ^ ^0.5 run function transformintoblocks:look_at_blocks/look_{block}\nexecute if entity @s[distance=4.5..] if block ~ ~ ~ air run scoreboard players set @s transform_id 0\nexecute if entity @s[distance=4.5..] if block ~ ~ ~ water run scoreboard players set @s transform_id 0\nexecute if entity @s[distance=4.5..] if block ~ ~ ~ light run scoreboard players set @s transform_id 0")
    look.close()

    look = open("look.mcfunction", "a")
    look.write(f"execute at @s anchored eyes run function transformintoblocks:look_at_blocks/look_{block}\n")
    look.close()
    
    transform = open(f"transform_into_blocks/transform_into_{block}.mcfunction", "w")
    transform.write(f"execute if score @s transform_id matches {i+1} at @s unless block ~ ~ ~ {block} run effect give @s minecraft:invisibility 1 0 true\nexecute unless block ~ ~ ~ {block} if score @s transform_id matches {i+1} if score @s timer matches ..{cooldown-1} at @s unless block ~ ~ ~ {block} run summon falling_block ~ ~ ~" + " {" + "NoGravity:1b,BlockState:{" + f"Name:{block}" + plus + "}" + "}\n" + f"execute unless block ~ ~ ~ {block} if score @s transform_id matches {i+1} if score @s timer matches {cooldown}.. at @s align x align y align z unless block ~ ~ ~ {block} if block ~ ~ ~ minecraft:air run summon falling_block ~0.5 ~ ~0.5" + " {" + "NoGravity:1b,BlockState:{" + f"Name:{block}" + plus + "}" + "}\n"+ f"execute unless block ~ ~ ~ {block} if score @s transform_id matches {i+1} if score @s timer matches {cooldown}.. at @s align x align y align z unless block ~ ~ ~ {block} if block ~ ~ ~ minecraft:water run summon falling_block ~0.5 ~ ~0.5" + " {" + "NoGravity:1b,BlockState:{" + f"Name:{block}" + plus + "}" + "}\n"+ f"execute unless block ~ ~ ~ {block} if score @s transform_id matches {i+1} if score @s timer matches {cooldown}.. at @s align x align y align z unless block ~ ~ ~ {block} if block ~ ~ ~ minecraft:light run summon falling_block ~0.5 ~ ~0.5" + " {" + "NoGravity:1b,BlockState:{" + f"Name:{block}" + plus + "}" + "}\n" + f"execute unless block ~ ~ ~ {block} if score @s transform_id matches {i+1} if score @s timer matches {cooldown}.. at @s unless block ~ ~ ~ {block} unless block ~ ~ ~ minecraft:air unless block ~ ~ ~ minecraft:water unless block ~ ~ ~ minecraft:light run summon falling_block ~ ~ ~" + " {" + "NoGravity:1b,BlockState:{" + f"Name:{block}" + plus + "}" + "}\n" + shulker)
    transform.close()

    transform = open("transform_into.mcfunction", "a")
    transform.write(f"execute as @a run function transformintoblocks:transform_into_blocks/transform_into_{block}\n")
    transform.close()


transform = open("transform_into.mcfunction", "a")
transform.write("kill @e[type=minecraft:falling_block, name=Old_Block]\n")
transform.close()